/*******************************************************
This program was created by the
CodeWizardAVR V3.12 Advanced
Automatic Program Generator
 Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 08.12.2018
Author  : 
Company : 
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*******************************************************/
 
#include <mega8.h>
#include <delay.h>

#define Rele_ON PORTC |= (1 << 0)   //   //-  
#define Rele_OFF PORTC &= ~(1 << 0) // 	
#define LED_yellow_220V_ON PORTC &= ~(1 << 1)   //  -  
#define LED_yellow_220V_OFF PORTC |= (1 << 1) // 


#define delay_ls 20      //  
#define FIRST_ADC_INPUT 4
#define LAST_ADC_INPUT 5
unsigned int adc_data[LAST_ADC_INPUT-FIRST_ADC_INPUT+1];
// Voltage Reference: AVCC pin
#define ADC_VREF_TYPE ((0<<REFS1) | (1<<REFS0) | (0<<ADLAR))


// Declare your global variables here
    //bit EXT_INT1_Flag;
    bit Menu_E_Flag;
    bit Menu_U_Flag;
    //bit Menu_U_Flag; 
    //bit svitch_ADC_Flag;
    char OK_Flag; 
    bit EXT_INT1_reaction_Flag;
    bit without_sound_Flag;
    bit STOP_FEN_Flag; 
    bit STOP_Avarija_Flag; 
    int ch_1[]; //   ADC  
   
    int ch_Fen; //   ADC 
    int ch_Iron; //   ADC     
    
    int Data_ch_Fen; //     
    int Data_ch_Iron; //     
    
    char EXT_INT0_reaction_Pause;
    char INT0_Flag;
    char INT0_mSek; 
    char INT0_Sek;
    bit Standby_Triger;
    char Menu_Triger;
    char Menu_Triger_UP;
    char Menu_Triger_Down; 
    char Menu_Triger_Right;
    char Menu_Triger_Left; 
    
    
    char Menu_F1,Menu_F2,Menu_F3,Menu_F4;
    bit svitch_ADC=0;//=1,  -0 
    char Indycator_Flag; //    
    char Step;  
    char button_Num; //   
    char Wite_button_time_incr;  //  
    char Wite_button_time=30; //   ()    
        
   char out_digit1= 18; 
   char out_digit2= 19;
   char out_digit3= 18;
   char out_digit4= 17; 
   char  cur_dig;
   
    flash char buf[] = {     //  
    0b00000011, //0
    0b10011111, //1 
    0b00100101, //2
    0b00001101, //3
    0b10011001, //4
    0b01001001, //5
    0b01000001, //6
    0b00011111, //7
    0b00000001, //8
    0b00001001, //9
    0b11111111, //blank
    0b01110001, //F
    0b00110001, //p 
    0b11100001, //t 
    0b11000001, //b
    0b11101110, //_.   
    0b01100001, //e 
    0b11100011, //L
    0b11000111, //v
    0b11110111,  //i 
    0b10000011,  //V 
    0b00010011,  // 
    0b11010101, //n
    0b11101111  //_   
                };
    flash char bufY[] = {     //     
    0b00000010, //0
    0b10011110, //1 
    0b00100100, //2
    0b00001100, //3
    0b10011000, //4
    0b01001000, //5
    0b01000000, //6
    0b00011110, //7
    0b00000000, //8
    0b00001000, //9
    0b0110000   //E
    //0b11010101, //n
    //0b00010011  //   
    //0b00010010,  //
    //0b11010100  //
                   };    
                      
  void hc164_wr(unsigned char dig, char h)  //    
{unsigned char a;
 for(a=0; a<8; a++){            //   8    
  if (h){PORTB.3 = bufY[dig] & 1<<a;} 
   else {PORTB.3 = buf[dig] & 1<<a;}   //   DATA   
   PORTB.4=0;         //  CLK  .0
   PORTB.4=1;         //  CLK  .1
                    }
 }

// ADC interrupt service routine
// with auto input scanning
interrupt [ADC_INT] void adc_isr(void)
{
static unsigned char input_index=0;
// Read the AD conversion result
adc_data[input_index]=ADCW;
// Select next ADC input
if (++input_index > (LAST_ADC_INPUT-FIRST_ADC_INPUT))
   input_index=0;
ADMUX=(FIRST_ADC_INPUT | ADC_VREF_TYPE)+input_index;
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=(1<<ADSC);
}

void numeric_convers(int ch_1)
{ 
 out_digit1 = ch_1 % 10;
 out_digit2 = (ch_1% 100) / 10;
 out_digit3 = (ch_1% 1000) / 100; 
}

void No_Indycator(void) 
  { 
   out_digit1 = 10;// 3 
   out_digit2 = 10;
   out_digit3 = 10;
  } 
  
 void adc_convers(void)
{
  switch (Indycator_Flag) {//    
    case 0 :{
        if (svitch_ADC) 
        { ch_1[0] = (adc_data[1])/2; //*5/1024)*10;  
          ch_Fen = ch_1[0];
          out_digit4= 11;}
          else  {ch_1[0] = (adc_data[0])/2; //*5/1024)*10
                 ch_Iron = ch_1[0];
                 out_digit4= 12;}  
                   
      numeric_convers(ch_1[0]);
          break;};  
    case 1 :{ //- "Srandby"
      out_digit1 = 15;
      out_digit2 = 14;
      out_digit3 = 13; 
      out_digit4 = 5;
          break;}; 
    case 2 :{ //- "Menu "
       out_digit4 = 16; //"E"
       if (Menu_E_Flag == 0){No_Indycator(); Menu_E_Flag=1;}
       if (svitch_ADC==1) {
        numeric_convers(Data_ch_Fen);
                          }  
       if (svitch_ADC==0) {
        numeric_convers(Data_ch_Iron);
                        } 
          break;};  
    case 3 :{ //- "Menu U" 
       Menu_F1=0; Menu_F2=0; Menu_F3=0;
       out_digit4 = 20; //"U"
       if (Menu_U_Flag == 0){No_Indycator(); Menu_U_Flag=1;}
          break;};
                         } 
}   
 
 void Port_Jet(void)
{
 PORTD|=(1<<4)|(1<<5)|(1<<6)|(1<<7);
}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Reinitialize Timer 0 value
TCNT0=0x83;
// Place your code here
  INT0_Flag++;
   if(INT0_Flag ==100){ //0,2  - 
   INT0_Flag =0;
   INT0_mSek++;   
   if ((STOP_Avarija_Flag)&& (without_sound_Flag)){PORTB.0= ~PORTB.0;}
   if (INT0_mSek == 5){  //1  - 
   INT0_Sek++;
   INT0_mSek =0;
   }
                     }
}
 // Timer2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
// Reinitialize Timer2 value
 TCNT2=0xCF;     //40
// Place your code here
  // adc_convers();
   switch (cur_dig)
   {   
case 0:{Port_Jet(); hc164_wr(out_digit1,Menu_F1); PORTD.7=0; #asm("nop")
         if (!(PINC&0b00001000))  //    PBC3
         {   //SW702  - Up
         if(Wite_button_time_incr < Wite_button_time){Wite_button_time_incr++;}
			else {Wite_button_time_incr=0; button_Num=2;}
         } 
         break;};  // 
case 1:{Port_Jet(); hc164_wr(out_digit2,Menu_F2); PORTD.6=0; #asm("nop")
        if(!(PINC&0b00000100))//    PBC2  PBC3 
           { //SW703 - "Menu"
           if(Wite_button_time_incr < Wite_button_time){Wite_button_time_incr++;}
			else {Wite_button_time_incr=0; button_Num=3;}
           }        
         if(!(PINC&0b00001000))//    PBC2  PBC3  
         {  //SW704 "-"
          if(Wite_button_time_incr < Wite_button_time){Wite_button_time_incr++;}
			else {Wite_button_time_incr=0; button_Num=4;}     
         }
          break;};  // 
case 2:{Port_Jet(); hc164_wr(out_digit3,Menu_F3); PORTD.5=0; #asm("nop")
        if(!(PINC&0b00000100))//    PBC2  PBC3 
         {  //SW705 - "Srandby"
          if(Wite_button_time_incr < Wite_button_time){Wite_button_time_incr++;}
			else {Wite_button_time_incr=0; button_Num=5;}
         }     
          if (!(PINC&0b00001000))  //    PBC3
         {   //SW706 - "Down"
         if(Wite_button_time_incr < Wite_button_time){Wite_button_time_incr++;}
			else {Wite_button_time_incr=0; button_Num=6;}
         } 
        break;};  // 
case 3:{Port_Jet(); hc164_wr(out_digit4,Menu_F4); PORTD.4=0; #asm("nop")
        if(!(PINC&0b00000100))//    PBC2  PBC3 
         { //SW707 "OK"
         if(Wite_button_time_incr < Wite_button_time){Wite_button_time_incr++;}
			else {Wite_button_time_incr=0; button_Num=7;}
         }     
         if(!(PINC&0b00001000))//    PBC2  PBC3  
        {   //SW708 "+" 
        if(Wite_button_time_incr < Wite_button_time){Wite_button_time_incr++;}
			else {Wite_button_time_incr=0; button_Num=8;}
        } 
        break;};  // 
  }      
    cur_dig++; 
    if (cur_dig==4) {cur_dig=0;}
    delay_us(800); //     
    PORTD.7=1;    //     
    PORTD.6=1;
    PORTD.5=1;
    PORTD.4=1; 
}

 void increment_Temperature(void) 
  {
     if (svitch_ADC==1) {
        Data_ch_Fen= Data_ch_Fen+Step;
                     }  
     if (svitch_ADC==0) {
        Data_ch_Iron=Data_ch_Iron+Step;
                     }
   }   
    
  void STOP_FEN(void)
  {  if (STOP_FEN_Flag){ 
     if(INT0_Sek ==0) {OCR1BL=0xFF;out_digit1 =7;} 
     if(INT0_Sek ==1) {OCR1BL=0xDF;out_digit1 =6;}
     if(INT0_Sek ==2) {OCR1BL=0xCF;out_digit1 =5;}  
     if(INT0_Sek ==3) {OCR1BL=0xBF;out_digit1 =4;}
     if(INT0_Sek ==4) {OCR1BL=0xAF;out_digit1 =3;}
     if(INT0_Sek ==5) {OCR1BL=0x5F;out_digit1 =2;} 
     if(INT0_Sek ==6) {OCR1BL=0x1F;out_digit1 =1;} 
     if(INT0_Sek ==7) {OCR1BL=0x00;out_digit1 =0;
                       INT0_Sek = 0;
                       STOP_FEN_Flag=0;}} 
     
  } 
   
  void decrement_Temperature(void) 
  {
   if ((svitch_ADC==1)&&(Data_ch_Fen >=Step))
                     {Data_ch_Fen= Data_ch_Fen-Step;}
           else {Data_ch_Fen=0;}            
     if ((svitch_ADC==0)&&(Data_ch_Iron >=Step)) 
                     {Data_ch_Iron= Data_ch_Iron-Step;}
  }
    

     
 void converts_Button (void)
{  
 if (button_Num==3)  //SW703 - "Menu" 
  { 
   switch (Menu_Triger) {//  =1   -0 
    case 0:{ 
             Menu_Triger=1;    //
             svitch_ADC = 1; //   Fen  
             without_sound_Flag=1; 
             Rele_ON; //   
             Menu_U_Flag = 0;
             STOP_FEN_Flag=0;
             OCR1AL=0x00;  //   
             break;};  
    case 1:{ 
             Menu_Triger=0;    //
             svitch_ADC = 0; //   Pajalnyk 
             Rele_OFF; //  
             without_sound_Flag=0; 
             INT0_Sek = 0;
             if (ch_Fen>=50){STOP_FEN_Flag=1;} 
             break;};
                      } 
  }
  if (button_Num==5)  
  {                        //SW705 - "Standby" 
       if (Standby_Triger==0){
         Rele_OFF; //  
         LED_yellow_220V_OFF;//    220     
         Indycator_Flag =1;// - "Srandby"
         Standby_Triger=1; //   
         OCR1AL=0x00;  //  
         STOP_FEN_Flag=1;//  
         Data_ch_Fen=0;
         Data_ch_Iron=0;
         STOP_Avarija_Flag=0;//   -            
                             }
         else {
         Indycator_Flag =0;// - "Srandby" - 
         Standby_Triger=0;
         without_sound_Flag=0;
                    }      
  }
  if (button_Num==7)    //SW707 "OK" 
  {   if (svitch_ADC==0) {
        switch (OK_Flag) {
         case 0 :{Indycator_Flag=2;
                OK_Flag=1; 
                break;};
         case 1 :{Indycator_Flag=0;// -   Menu
                  OK_Flag=0;
                  Menu_F1=0; Menu_F2=0; Menu_F3=0;
                  OCR1AL=0xCF;//  
                  Menu_U_Flag = 0;
                  Menu_E_Flag = 0; 
                break;};
                        }
                        }
     else{ 
                      
      switch (OK_Flag) {//    
       case 0 :{Indycator_Flag=2;
                OK_Flag=1; 
                break;};
       case 1 :{Indycator_Flag=3;// -   Menu
                OK_Flag=2;
                without_sound_Flag=1;// 
                break;};
       case 2 :{Indycator_Flag=0;// -   Menu
                OK_Flag=0;
                Menu_Triger_UP=0;
                Menu_Triger_Down=0;
                //Menu_U_Flag=0;
                Rele_ON;
                break;};         
                }
          } 
 }   

   if (button_Num==2) //SW702 - "Up"
  { 
     switch (Menu_Triger_UP){  
        case 0:{increment_Temperature();
                if (Indycator_Flag==3) {Menu_Triger_UP=1;}  
                break;};  
        case 1:{out_digit3 = 23; 
                out_digit2 = 23;
                out_digit1 = 23;
                OCR1BL=0x5F;
                Menu_Triger_Down=Menu_Triger_UP;
                Menu_Triger_UP=2;
                break;};
        case 2:{out_digit3 = 22; 
                out_digit2 = 22;
                out_digit1 = 22;
                OCR1BL=0xBF;
                Menu_Triger_Down=Menu_Triger_UP;
                Menu_Triger_UP=3;
                break;};
        case 3:{out_digit3 = 21; 
                out_digit2 = 21;
                out_digit1 = 21;
                OCR1BL=0xFF;
                Menu_Triger_Down=1;
                //Menu_Triger_UP=1;
                break;};                
                 
  }                       }
  
   if (button_Num==6) //  =1   -0 
  {              //SW706 - "Down" 
   switch (Menu_Triger_Down){  
        case 0:{decrement_Temperature();
                if (Indycator_Flag==3) {Menu_Triger_Down=1;}
                break;};  
        case 1:{out_digit3 = 21; 
                out_digit2 = 21;
                out_digit1 = 21;
                OCR1BL=0xFF;
                Menu_Triger_UP=Menu_Triger_Down;
                Menu_Triger_Down=2;
                break;};
        case 2:{out_digit3 = 22; 
                out_digit2 = 22;
                out_digit1 = 22;
                OCR1BL=0xBF;
                Menu_Triger_UP=Menu_Triger_Down;
                Menu_Triger_Down=3;
                break;};
        case 3:{out_digit3 = 23; 
                out_digit2 = 23;
                out_digit1 = 23;
                OCR1BL=0x5F;
                Menu_Triger_UP=1;
                //Menu_Triger_Down=1;
                break;}; }
  }   
 
     if (button_Num==4)   //SW704 "Left"  
  {      
    if (Indycator_Flag==2){        
       switch (Menu_Triger_Left){  
        case 0:{
                Menu_F3=0;
                Menu_F1=1;
                Menu_Triger_Left = 1;
                Menu_Triger_Right= Menu_Triger_Left;
                Step =1;
                break;};  
        case 1:{
                Menu_F1=0;
                Menu_F2=1;
                Menu_Triger_Left = 2;
                Menu_Triger_Right= Menu_Triger_Left;
                 Step =10;
                break;}; 
        case 2:{
                Menu_F2=0;
                Menu_F3=1;
                Menu_Triger_Left = 0;
                Menu_Triger_Right= Menu_Triger_Left;
                Step =100;              
                break;};
         }  
                       }
 button_Num=0;  
  } 
  
  if (button_Num==8)    //SW708 "Right" 
  {
   if (Indycator_Flag==2){ 
     switch (Menu_Triger_Right){  
        case 0:{Step =100;
                Menu_F1=0;
                Menu_F3=1;
                Menu_Triger_Right = 1;
                Menu_Triger_Left = Menu_Triger_Right;
                break;};  
        case 1:{Step =10;
                Menu_F3=0;
                Menu_F2=1;
                Menu_Triger_Right = 2;
                Menu_Triger_Left = Menu_Triger_Right;
                break;}; 
        case 2:{Step =1;
                Menu_F2=0;
                Menu_F1=1;
                Menu_Triger_Right = 0;
                Menu_Triger_Left = Menu_Triger_Right;
                break;};         
                }
     }           
    }
  button_Num=0;                      
}
 
 
 
 void Analize_controll_temperature (void)
 { 
     if ((svitch_ADC)&&(Indycator_Flag==0)&&(ch_Fen < Data_ch_Fen)&&(EXT_INT1_reaction_Flag==0))
         {LED_yellow_220V_ON;  //    
         }
           else  {LED_yellow_220V_OFF;}  //    220  
          if (ch_Fen > 400) {LED_yellow_220V_OFF;  //    220  
                             STOP_FEN_Flag=1;}//   
                                     
     if ((svitch_ADC==0)&&(Indycator_Flag==0)&&(ch_Iron < Data_ch_Iron))
            {OCR1AL=0xDF;}// 
      else  {OCR1AL=0x00;}// 
 }  
 
  void EXT_INT0_reaction (void) //   
 { if (PIND & (1<<PIND2)){ //   D2-1  -   
    
     if ((PIND & (1<<PIND2))&& (INT0_Sek > EXT_INT0_reaction_Pause)&&(Indycator_Flag ==0)) {////    
     Rele_OFF; //  
       STOP_Avarija_Flag=1;//  
       } 
      EXT_INT0_reaction_Pause = INT0_Sek; 
       }
     else {STOP_Avarija_Flag=0;}
 }  
 
void EXT_INT1_reaction (void)  //   
 { if(!(PIND&0b00001000)) {EXT_INT1_reaction_Flag=1;}
     else {EXT_INT1_reaction_Flag=0;} 
 }

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Function: Bit7=Out Bit6=Out Bit5=Out Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=Out 
DDRB=(1<<DDB7) | (1<<DDB6) | (1<<DDB5) | (1<<DDB4) | (1<<DDB3) | (1<<DDB2) | (1<<DDB1) | (1<<DDB0);
// State: Bit7=0 Bit6=0 Bit5=0 Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=0 
PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);

// Port C initialization
// Function: Bit6=Out Bit5=In Bit4=In Bit3=In Bit2=In Bit1=Out Bit0=Out 
DDRC=(1<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (0<<DDC2) | (1<<DDC1) | (1<<DDC0);
// State: Bit6=0 Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T 
PORTC=(0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);

// Port D initialization
// Function: Bit7=Out Bit6=Out Bit5=Out Bit4=Out Bit3=In Bit2=In Bit1=Out Bit0=Out 
DDRD=(1<<DDD7) | (1<<DDD6) | (1<<DDD5) | (1<<DDD4) | (0<<DDD3) | (0<<DDD2) | (1<<DDD1) | (1<<DDD0);
// State: Bit7=0 Bit6=0 Bit5=0 Bit4=0 Bit3=T Bit2=T Bit1=0 Bit0=0 
PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (0<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 125,000 kHz
TCCR0=(0<<CS02) | (1<<CS01) | (1<<CS00);
TCNT0=0x83;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
// Mode: Ph. correct PWM top=OCR1A
// OC1A output: Non-Inverted PWM
// OC1B output: Non-Inverted PWM
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer Period: 0 us
// Output Pulse(s):
// OC1A Period: 0 us
// OC1B Period: 0 us
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off

TCCR1A=0b10100001;
TCCR1B=0b00000011;     
TCNT1 = 0;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x50;//OCR1AL=0x64;  // 
OCR1BH=0x00;
OCR1BL=0xF0;//OCR1BL=0x64;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
// Mode: Normal top=0xFF
// OC2 output: Disconnected
// Timer Period: 9,984 ms
ASSR=0<<AS2;
TCCR2=(0<<PWM2) | (0<<COM21) | (0<<COM20) | (0<<CTC2) | (1<<CS22) | (1<<CS21) | (1<<CS20);
TCNT2=0xB2;
OCR2=0x00;
   /*
// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Low level
// INT1: On
// INT1 Mode: Low level
GICR|=(1<<INT1) | (1<<INT0);
MCUCR=(0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);
GIFR=(1<<INTF1) | (1<<INTF0);
   */    
 // External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=(0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);  
   
// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=(0<<OCIE2) | (1<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (1<<TOIE0);

// Analog Comparator initialization
// Analog Comparator: Off
// The Analog Comparator's positive input is
// connected to the AIN0 pin
// The Analog Comparator's negative input is
// connected to the AIN1 pin
ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);

// ADC initialization
// ADC Clock frequency: 125,000 kHz
// ADC Voltage Reference: AVCC pin
ADMUX=FIRST_ADC_INPUT | ADC_VREF_TYPE;
ADCSRA=(1<<ADEN) | (1<<ADSC) | (0<<ADFR) | (0<<ADIF) | (1<<ADIE) | (1<<ADPS2) | (1<<ADPS1) | (0<<ADPS0);
SFIOR=(0<<ACME);


// Global enable interrupts
#asm("sei")
delay_ms(1000);
button_Num=5;// 

while (1)
      {
      // Place your code here
          converts_Button(); 
          adc_convers();
          Analize_controll_temperature(); 
          EXT_INT0_reaction();
          EXT_INT1_reaction();
          STOP_FEN();
          
         
      }
}